#!/usr/bin/haserl
Content-Type: text/javascript

Scada.Comfoway = {};

var $CW = Scada.Comfoway;
$CW.pList = [ 'general', 'command', 'status']; //, 'event', 'general'];

$CW.buttons = [];

//not 4 spc
$CW.helpersRestore = function() {
  Ext.Msg.confirm(
    $tr('scripting_tools_helpers_restore'),
    $tr('scripting_tools_helpers_restore_confirm'),
    function(res) {
      if (res == 'yes') {
        Ext.Ajax.request({
          url: Scada.genUrl('scripting-helpers-restore')
        });
      }
    }
  );
};

//not 4 spc
$CW.backup = function() {
  Ext.Msg.confirm(
    $tr('scripting_tools_backup'),
    $tr('scripting_tools_backup_confirm'),
    function(res) {
      window.open(Scada.genUrl('scripting-backup') + '?full=' + res);
    }
  );
};

$CW.storeFields = [ 'id', 'type', 'name','nameLong', 'description', 'datatype', 'address', 'address2', 'address3', 'address4', 'address5', 'address6', 'address7', 'address8', 'active', 'updateonly', 'interval', 'wrold', 'datahex' ];

Ext.each($CW.pList, function(item) {
  var name = item[ 0 ], sorter = 'id';

  $CW[ name + 'GridStore' ] = new Ext.ux.data.PagingJsonStore({
    data: [],
    fields: $CW.storeFields ,
    sortInfo: { field: sorter, direction: 'ASC' }
  });
});


Ext.each($CW.pList, function(item) {
  var name = item[ 0 ], sorter = 'id';

  $CW[ name + 'Store' ] = new Ext.data.JsonStore({
    url: Scada.reqUrl('comfoway'),
    baseParams: Scada.encodeData({ type: item }),
    root: 'data',
    fields: $CW.storeFields 
  });

  $CW.buttons.push({
    id: 'comfoway-btn-' + item,
    text: $tr('comfoway_' + item),
    iconCls: 'scada-comfoway-btn-' + item,
//    hidden: (item == 'resident2') ? false : true,
    pressed: (item == 'command'),
//    cls: 'scripting-button',
//    xtype:  (item == 'general') ? 'button' : 'splitbutton', scale: 'large', iconAlign: 'bottom', arrowAlign: 'bottom', minWidth: 120,
    xtype: 'splitbutton', scale: 'large', iconAlign: 'bottom', arrowAlign: 'bottom', minWidth: 120,
    menu: {
      items: [
        { text: $tr('comfoway_list_view'), iconCls: 'icon-list-view', id: 'comfoway-menu-' + item + '-list'  },
        { text: $tr('comfoway_btn_add') , iconCls: 'icon-add', id: 'comfoway-menu-' + item + '-add',hidden: (item == 'general') ? false : true }
      ]
    }
  });

  $CW[name + 'Pagination'] = new Ext.ux.PagingToolbar({
    pageSize: Config.perpage,
    store: $CW[ name + 'GridStore' ],
    displayMsg: $tr('comfoway_'+name+'_pages_hint'),
    emptyMsg: $tr('comfoway_'+name+'_pages_empty'),
    beforePageText: $tr('page'),
    afterPageText: $tr('page_of'),
  });
});

$CW.buttons.push({
  text: $tr('comfoway_reload'),
//  hidden: true,
  iconCls: 'scada-comfoway-btn-noreload',
  id: 'reloadBtn',
  cls: 'comfoway-rel-button',
  disabled: true,
//  margins: {top:0, right:0, bottom:0, left:50},
  handler: function() {
    Ext.Ajax.request({
      url: Scada.reqUrl('comfoway', 'reload'),
    });
//    $CW.enableReload(false);
//    Ext.Msg.alert($tr('comfoway_reload_alert_title'), $tr('comfoway_reload_alert_msg'));
    Ext.Msg.show({
       title:$tr('comfoway_reload_alert_title'),
       msg: $tr('comfoway_reload_alert_msg'),
       buttons: Ext.Msg.OK,
       fn: $U.pageReload,
       icon: Ext.MessageBox.WARNING
    });
    
  },
  xtype: 'button', scale: 'large', iconAlign: 'bottom', arrowAlign: 'bottom', minWidth: 120
// www.sencha.com/forum/showthread.php?48184-How-to-align-two-buttons-in-two-different-side
});

$CW.buttons.push({
  text: $tr('comfoway_modbus'),
//  hidden: true,
  iconCls: 'scada-comfoway-btn-modbus',
  id: 'modbusBtn',
  cls: 'comfoway-rel-button',
//  disabled: true,
//  margins: {top:0, right:0, bottom:0, left:50},
  handler: function() { window.open('/modbus.html') },
  xtype: 'button', scale: 'large', iconAlign: 'bottom', arrowAlign: 'bottom', minWidth: 120
// www.sencha.com/forum/showthread.php?48184-How-to-align-two-buttons-in-two-different-side
});

$CW.initReload = function() {
  
  Ext.Ajax.request({
    url: Scada.reqUrl('comfoway', 'getchanges'),
    callback: function(options, success, response) {
      var relBtn = Ext.getCmp('reloadBtn');
      console.log('data: ',success, response.responseText=='{"changes":true,"success":true}', response.responseText);
      if (success) {
        $CW.enableReload(response.responseText=='{"changes":true,"success":true}');
      }
    },
  });
}

$CW.enableReload = function(enble) {
  var relBtn = Ext.getCmp('reloadBtn');
  if (enble) {
    relBtn.enable();
    relBtn.setIconClass('scada-comfoway-btn-reload');
    Ext.Ajax.request({
      url: Scada.reqUrl('comfoway', 'setchanges'),
    });
  } else {
    relBtn.disable();
    relBtn.setIconClass('scada-comfoway-btn-noreload');
  } 
}
$CW.storeFields = [ 'id', 'type', 'name', 'description', 'datatype', 'address', 'address2', 'address3', 'address4', 'address5', 'address6', 'address7', 'address8', 'active', 'updateonly', 'interval' ];

$CW.myGAdecoder = function(value, metaData, record, rowIndex, colIndex, store) {
  if (value+0==0) {return ''} else {return Scada.decodeGroupAddress(value, metaData, record, rowIndex, colIndex, store)}
};

$CW.gGrid = new Ext.grid.GridPanel($def.grid({
  id: 'comfoway-grid-general',
  store: $CW.gGridStore,
  ctCls: 'scada-list-view-grid',
  loadMask: true,

  colModel: new Ext.grid.ColumnModel({
    columns: [
      { header: $tr('spcway_id'), width: 0.10, dataIndex: 'id', hidden: true },
      { header: $tr('spcway_name'), width: 0.1, dataIndex: 'name' },
      { header: $tr('spcway_value'), width: 0.1, dataIndex: 'datahex' },
      { header: $tr('spcway_description'), width: 0.5, dataIndex: 'description' },
//      { header: $tr('scripting_type'), width: 0.15, dataIndex: 'type' },
//      { header: $tr('scripting_duplicate'), width: 0.05, xtype: 'boolclscolumn', falseCls: 'scada-cell-duplicate', dataIndex: 'duplicate', hidden: true },
//      { header: $tr('scripting_editor'), width: 0.05, xtype: 'boolclscolumn', falseCls: 'scada-cell-editor', dataIndex: 'editor' },
//      { header: $tr('scripting_active'), width: 0.05, xtype: 'boolclscolumn', dataIndex: 'active' },
      { header: '', width: 0.05, xtype: 'boolclscolumn', falseCls: 'scada-cell-delete', dataIndex: 'delete' }
    ]
  }),
  bbar: [
    { text: $tr('spcway_btn_add'), iconCls: 'icon-add', id: 'comfoway-bbar-' + 'general' + '-add' },
    $CW.gPagination,
  ]
}));


$CW.sGrid = new Ext.grid.GridPanel($def.grid({
  id: 'comfoway-grid-status',
  store: $CW.sGridStore,
  ctCls: 'scada-list-view-grid',
  loadMask: true,

  colModel: new Ext.grid.ColumnModel({
    columns: [
      { header: $tr('comfoway_id'), width: 0.10, dataIndex: 'id', hidden: true },
      { header: $tr('comfoway_status'), width: 0.12, dataIndex: 'name', hidden:true },
      { header: $tr('comfoway_status'), width: 0.20, dataIndex: 'nameLong' },
      { header: $tr('comfoway_address'), width: 0.06, dataIndex: 'address' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_address') + ' 2', width: 0.06, dataIndex: 'address2' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_address') + ' 3', width: 0.06, dataIndex: 'address3' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_address') + ' 4', width: 0.06, dataIndex: 'address4' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_address') + ' 5', width: 0.06, dataIndex: 'address5' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_datatype'), width: 0.12, dataIndex: 'datatype', trPrefix: 'objects_datatype', xtype: 'translatecolumn'},
      { header: $tr('comfoway_description'), width: 0.4, dataIndex: 'description' },
      { header: $tr('scripting_active'), width: 0.05, xtype: 'boolclscolumn', dataIndex: 'active' },
    ]
  }),
  bbar: [
//    { text: $tr('comfoway_btn_add'), iconCls: 'icon-add', id: 'comfoway-bbar-' + 'status' + '-add' },
    $CW.sPagination,
  ],
}));

$CW.cGrid = new Ext.grid.GridPanel($def.grid({
  id: 'comfoway-grid-command',
  store: $CW.cGridStore,
  ctCls: 'scada-list-view-grid',
  loadMask: true,

  colModel: new Ext.grid.ColumnModel({
    columns: [
      { header: $tr('comfoway_id'), width: 0.10, dataIndex: 'id', hidden: true },
      { header: $tr('comfoway_command'), width: 0.12, dataIndex: 'name', hidden: true },
      { header: $tr('comfoway_command'), width: 0.20, dataIndex: 'nameLong' },
      { header: $tr('comfoway_address'), width: 0.06, dataIndex: 'address' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_address') + ' 2', width: 0.06, dataIndex: 'address2' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_address') + ' 3', width: 0.06, dataIndex: 'address3' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_address') + ' 4', width: 0.06, dataIndex: 'address4' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_address') + ' 5', width: 0.06, dataIndex: 'address5' , renderer: $CW.myGAdecoder},
      { header: $tr('comfoway_datatype'), width: 0.12, dataIndex: 'datatype', trPrefix: 'objects_datatype', xtype: 'translatecolumn'},
      { header: $tr('comfoway_description'), width: 0.4, dataIndex: 'description' },
      { header: $tr('scripting_active'), width: 0.05, xtype: 'boolclscolumn', dataIndex: 'active' },
    ]
  }),
  bbar: [
//    { text: $tr('comfoway_btn_add'), iconCls: 'icon-add', id: 'comfoway-bbar-' + 'command' + '-add' },
    $CW.cPagination,
  ],
}));

$CW.dtSelect = $def.select({
  fieldLabel: $tr('comfoway_datatype'),
  name: 'datatype',
  emptyText: $tr('objects_datatype_'),
  triggerAction: 'all',
  hiddenName: 'datatype',
  valueField: 'value',
  displayField: 'display',
  mode: 'local', 
  allowBlank: false,
  tpl: '<tpl for="."><div class="x-combo-list-item scada-combo-item-{extraCls}">{display}</div></tpl>',
  disabled: true
});
$CW.dataTypes = new Ext.data.ArrayStore({
  fields: ['value', 'display', 'extraCls'],
  idIndex: 0,
  data: [
    ['',   $tr('objects_datatype_'), 'unspec' ],
    ['1',  $tr('objects_datatype_1'), 'main'],
//    ['1001',  $tr('objects_datatype_1001'), 'sub'],
//    ['1002',  $tr('objects_datatype_1002'), 'sub'],
//    ['1003',  $tr('objects_datatype_1003'), 'sub'],
//    ['1004',  $tr('objects_datatype_1004'), 'sub'],
    ['1005',  $tr('objects_datatype_1005'), 'sub'],
//    ['1006',  $tr('objects_datatype_1006'), 'sub'],
//    ['1007',  $tr('objects_datatype_1007'), 'sub'],
//    ['1008',  $tr('objects_datatype_1008'), 'sub'],
//    ['1009',  $tr('objects_datatype_1009'), 'sub'],
//    ['1010',  $tr('objects_datatype_1010'), 'sub'],
    ['1011',  $tr('objects_datatype_1011'), 'sub'],
//    ['1012',  $tr('objects_datatype_1012'), 'sub'],
//    ['1013',  $tr('objects_datatype_1013'), 'sub'],
//    ['1014',  $tr('objects_datatype_1014'), 'sub'],
    ['2',  $tr('objects_datatype_2'), 'main'],
    ['3',  $tr('objects_datatype_3'), 'main'],
    ['3007',  $tr('objects_datatype_3007'), 'sub'],
    ['4',  $tr('objects_datatype_4'), 'main'],
    ['5',  $tr('objects_datatype_5'), 'main'],
    ['5001',  $tr('objects_datatype_5001'), 'sub'],
    ['5003',  $tr('objects_datatype_5003'), 'sub'],
    ['6',  $tr('objects_datatype_6'), 'main'],
    ['7',  $tr('objects_datatype_7'), 'main'],
    ['8',  $tr('objects_datatype_8'), 'main'],
    ['9',  $tr('objects_datatype_9'), 'main'],
    ['9001',  $tr('objects_datatype_9001'), 'sub'],
    ['254', $tr('objects_datatype_254'), 'main'],
    ['10', $tr('objects_datatype_10'), 'main'],
    ['11', $tr('objects_datatype_11'), 'main'],
    ['12', $tr('objects_datatype_12'), 'main'],
    ['13', $tr('objects_datatype_13'), 'main'],
    ['14', $tr('objects_datatype_14'), 'main'],
    ['15', $tr('objects_datatype_15'), 'main'],
    ['16', $tr('objects_datatype_16'), 'main'],
    ['16002', $tr('objects_datatype_16002'), 'sub']
  ]
});


$CW.elementStore= new Ext.data.JsonStore({
  fields: ['type','value'],
  root: 'url',
  idProperty: 'type',
  baseParams: Scada.encodeData({ type: 'elementURL' }),
  url: Scada.reqUrl('comfoway', 'classstore')
});

$CW.setToolTip = function(ttiphtml,type) {
  if (type == 'User') {
    ttiphtml = '<b>*</b> : All<br>1 : Christof<br>2 : Amaryllis<br>3 : Louis';
  } else if (type == 'Door') {
    ttiphtml = '<b>*</b> : All<br>1 : Voordeur<br>2 : Keukendeur<br>3 : Garagepoort';
  }  else {
    ttiphtml = '';
  }
console.log(ttiphtml,type);
};

$CW.getToolTip = function(eltype,fldtype) {
  var res = ''
console.log('get tip',eltype,fldtype);
  $CW.elementStore.each(function(val) {if (val.id == eltype) {res = val.data.value}})

  if (fldtype == 'eventid') {res = $tr('comfoway_tiptext_evtid') + res }   
  else if (fldtype == 'eventoption') { res = $tr('comfoway_tiptext_evtoption') + res }
  else if (fldtype == 'commandid') {res = $tr('comfoway_tiptext_cmdid') + res }   
  else if (fldtype == 'commandoption') { res = $tr('comfoway_tiptext_cmdoption') }
  else if (fldtype == 'statusid') { res = $tr('comfoway_tiptext_stsid') + res }
  else if (fldtype == 'statusoption') { res = $tr('comfoway_tiptext_stsoption') + res }

  return res;
};

$CW.setLabel = function(field,label){
    var el = field.el.dom.parentNode.parentNode;
    if( el.children[0].tagName.toLowerCase() === 'label' ) {
        el.children[0].innerHTML =label;
    }else if( el.parentNode.children[0].tagName.toLowerCase() === 'label' ){
    el.parentNode.children[0].innerHTML =label;
    }
//    return setLabel; //just for fun
};


$CW.sFormWindow = new Ext.Window($def.window({
  title: $tr('comfoway_status_form'),
  width: 460,
  height: 540, //440

  items: $def.form({
    id: 'comfoway-status-form',
    url: Scada.reqUrl('comfoway', 'save'),
    items: [
      { id: 'comfoway-status-name', fieldLabel: $tr('comfoway_status') , name:'name', disabled:true, hidden:true},
      { id: 'comfoway-status-nameLong', fieldLabel: $tr('comfoway_status') , name:'nameLong', disabled:true},
      { id:'comfoway-status-form-description', fieldLabel: $tr('comfoway_description'), name: 'description', xtype: 'textarea', height: 90, disabled:true},
        $extend($CW.dtSelect, { store: $CW.dataTypes }),
      { fieldLabel: $tr('comfoway_active'), name: 'active', xtype: 'checkbox' },
      { id:'comfoway-status-form-updateonly', fieldLabel: $tr('comfoway_updateonly'), name: 'updateonly', xtype: 'checkbox',hidden:false },
      { id:'comfoway-status-form-wrold', fieldLabel: $tr('comfoway_wrold'), name: 'wrold', xtype: 'checkbox',hidden:false },
      { id:'comfoway-status-form-address', fieldLabel: $tr('comfoway_address'), name: 'address' , allowBlank: false, vtype: 'knxga'},
      { id:'comfoway-status-form-address2', fieldLabel: $tr('comfoway_address') +' 2', name: 'address2', vtype:'knxga'},
      { id:'comfoway-status-form-address3', fieldLabel: $tr('comfoway_address') +' 3', name: 'address2', vtype:'knxga'},
      { id:'comfoway-status-form-address4', fieldLabel: $tr('comfoway_address') +' 4', name: 'address2', vtype:'knxga'},
      { id:'comfoway-status-form-address5', fieldLabel: $tr('comfoway_address') +' 5', name: 'address2', vtype:'knxga'},
      { id:'comfoway-status-form-address6', fieldLabel: $tr('comfoway_address') +' 6', name: 'address2', vtype:'knxga'},
      { id:'comfoway-status-form-address7', fieldLabel: $tr('comfoway_address') +' 7', name: 'address2', vtype:'knxga'},
      { id:'comfoway-status-form-address8', fieldLabel: $tr('comfoway_address') +' 8', name: 'address2', vtype:'knxga'},
      { id: 'comfoway-status-form-interval', fieldLabel: $tr('comfoway_interval'), name: 'interval' , allowBlank: true, regex:/^(\d+)$/},
      { name: 'id', xtype: 'hidden' },
      { name: 'type', xtype: 'hidden', id: 'comfoway-status-form-type' }
    ],
    buttons: $def.formButtons('comfoway-status-form')
  })
}));


$CW.cFormWindow = new Ext.Window($def.window({
  title: $tr('comfoway_command_form'),
  width: 460,
  height: 470, //440

  items: $def.form({
    id: 'comfoway-command-form',
    url: Scada.reqUrl('comfoway', 'save'),
    items: [
      { id: 'comfoway-command-name', fieldLabel: $tr('comfoway_command') , name:'name', disabled:true, hidden:true},
      { id: 'comfoway-command-nameLong', fieldLabel: $tr('comfoway_command') , name:'nameLong', disabled:true},
      { id:'comfoway-command-form-description', fieldLabel: $tr('comfoway_description'), name: 'description', xtype: 'textarea', height: 90, disabled:true},
        $extend($CW.dtSelect, { store: $CW.dataTypes }),
      { fieldLabel: $tr('comfoway_active'), name: 'active', xtype: 'checkbox' },
      { id:'comfoway-command-form-updateonly', fieldLabel: $tr('comfoway_updateonly'), name: 'updateonly', xtype: 'checkbox',hidden:true },
      { id:'comfoway-command-form-wrold', fieldLabel: $tr('comfoway_wrold'), name: 'wrold', xtype: 'checkbox',hidden:true },
      { id:'comfoway-command-form-address', fieldLabel: $tr('comfoway_address'), name: 'address' , allowBlank: false, vtype: 'knxga'},
      { id:'comfoway-command-form-address2', fieldLabel: $tr('comfoway_address') +' 2', name: 'address2', vtype:'knxga'},
      { id:'comfoway-command-form-address3', fieldLabel: $tr('comfoway_address') +' 3', name: 'address2', vtype:'knxga'},
      { id:'comfoway-command-form-address4', fieldLabel: $tr('comfoway_address') +' 4', name: 'address2', vtype:'knxga'},
      { id:'comfoway-command-form-address5', fieldLabel: $tr('comfoway_address') +' 5', name: 'address2', vtype:'knxga'},
      { id:'comfoway-command-form-address6', fieldLabel: $tr('comfoway_address') +' 6', name: 'address2', vtype:'knxga'},
      { id:'comfoway-command-form-address7', fieldLabel: $tr('comfoway_address') +' 7', name: 'address2', vtype:'knxga'},
      { id:'comfoway-command-form-address8', fieldLabel: $tr('comfoway_address') +' 8', name: 'address2', vtype:'knxga'},
      { id: 'comfoway-command-form-interval', fieldLabel: $tr('comfoway_interval'), name: 'interval' , allowBlank: true, regex:/^(\d+)$/, hidden:true},
      { name: 'id', xtype: 'hidden' },
      { name: 'type', xtype: 'hidden', id: 'comfoway-command-form-type' }
    ],
    buttons: $def.formButtons('comfoway-command-form')
  })
}));

$CW.setGeneralRegex = function() {
  var genCB = Ext.getCmp('comfoway-general-form-name');
  var genVal = Ext.getCmp('comfoway-general-form-value');
  var str = genCB.getValue();
  if (str.substring(0,14)=='modbus.profile') {
    genVal.regex = new RegExp('^[0-1]$');
//    genVal.validate();
  } else if (str=='comfoair.connect.type') {
    genVal.regex = new RegExp('^(serial|tcpclient)$');
  } else if (str=='comfoair.connect.port') {
    genVal.regex = new RegExp("^(\\/[a-zA-Z0-9\\.\\/\\-_]+|[0-9]+)*$");
  } else if (str=='comfoair.connect.host') {
    genVal.regex = new RegExp("^(|[a-zA-Z0-9\\.]+)*$");
  } else if (str=='modbus.connect.disabled') {
    genVal.regex = new RegExp('^[0-1]$');
//    genVal.validate();
  } else if (str=='modbus.connect.type') {
    genVal.regex = new RegExp('^(tcp|rtu)$');
  } else if (str=='modbus.connect.params') {
    genVal.regex = new RegExp("^((ip|ipport|rsport|baud|parity|duplex|databits|stopbits)\\s*=\\s*([0-9]+|'[a-zA-Z0-9\\.]+')\\s*)(,\\s*(ip|ipport|rsport|baud|parity|duplex|databits|stopbits)\\s*=\\s*([0-9]+|'[a-zA-Z0-9\\.]+')\\s*)*$");
  } else if (str.substring(0,7)=='modbus.') {
    genVal.regex = new RegExp('^[0-9]+$');
  } else if (str=='DEBUG') {
    genVal.regex = new RegExp('^[0-4]$');
  } else {
    genVal.regex = new RegExp('^[0-9]+$');
//    genVal.validate();
  }
  genVal.setValue(genVal.getValue());
};

$CW.gFormWindow = new Ext.Window($def.window({
  title: $tr('comfoway_general_form'),
  width: 460,
  height: 300,

  items: $def.form({
    id: 'comfoway-general-form',
    url: Scada.reqUrl('comfoway', 'save'),
    items: [
//      { fieldLabel: $tr('spcway_name'), name: 'name', allowBlank: false, disabled: true , id:'comfoway-general-form-name'},
      { id: 'comfoway-general-form-name', fieldLabel: $tr('spcway_name'), name: 'name', allowBlank: false, xtype: 'combo', triggerAction:'all', store: ['comfoair.connect.type','comfoair.connect.port','comfoair.connect.host','DEBUG','modbus.connect.type','modbus.connect.slaveid','modbus.connect.params','modbus.connect.disabled','modbus.profile.stable','modbus.profile.usecoils'], allowBlank: false , listeners :{'valid' : $CW.setGeneralRegex } },
//      { fieldLabel: $tr('spcway_value'), name: 'value', xtype: 'numberfield', allowBlank: false, minValue: 0, allowDecimals: false },
      {  id: 'comfoway-general-form-value', fieldLabel: $tr('spcway_value'), name: 'datahex', xtype: 'textfield', allowBlank: true, regex:/^[0-9]+$/ },
      { fieldLabel: $tr('comfoway_description'), name: 'description', xtype: 'textarea', height: 90, disabled: true, id:'comfoway-general-form-desc' },
      { name: 'id', xtype: 'hidden' },
      { name: 'type', xtype: 'hidden', id: 'comfoway-general-form-type' }
    ],
    buttons: $def.formButtons('comfoway-general-form')
  })
}));


$CW.restoreWindow = new Ext.Window($def.window({
//not needed 4 spc
  title: $tr('scripting_restore_form'),
  width: 460,
  height: 200,

  items: $def.form({
    id: 'scripting-restore-form',
    url: Scada.genUrl('scripting-restore'),
    fileUpload: true,
    labelWidth: 100,
    defaults: { width: 300 },
    items: [
      { fieldLabel: $tr('scripting_restore_mode'), name: 'mode', xtype: 'radiogroup', columns: 1,
        items: [
          { xtype: 'radio', boxLabel: $tr('scripting_restore_overwrite'), checked: true, name: 'mode', inputValue: 'overwrite' },
          { xtype: 'radio', boxLabel: $tr('scripting_restore_append'), name: 'mode', inputValue: 'append' }
        ]
      },
      $def.fileUpload({ id: 'form-file', fieldLabel: $tr('scripting_restore_file') })
    ],
    buttons: $def.formButtons('scripting-restore-form')
  })
}));

//this is the comfoway grid panel area
$CW.mainSpcPanel = new Ext.Panel({
  id: 'comfoway-main-container',
  layout: 'card',
  margins: '10 10 10 10',
  border: false,
  activeItem: 0,
  flex: 1,
  items: [ $CW.cGrid, $CW.sGrid ,  $CW.gGrid]
});

//this is the comfoway tab
$CW.container = new Ext.Container({
  id: 'Comfoway',
  title: $tr('comfoway_title'),
  layout: 'vbox',
  layoutConfig: { align : 'stretch' },
  items: [
    { layout: 'column', ctCls: 'x-comfoway-menu', autoHeight: false, border: false, margins: '10 10 0 10', height: 71, items: $CW.buttons },
    $CW.mainSpcPanel
  ]
});

$CW.onConfirmComplete = function() {
console.log('onConfirmComplete ',this)
  $CW[ this.name + 'Store' ].reload();
  $CW[ this.name + 'GridStore' ].reload();
  $CW.enableReload(true);
};

//function called after gridaction is confirmed
$CW.onConfirm = function(confirmResult) {
  var grid;
  if (confirmResult == 'yes') {
    grid = $CW[ this.name + 'Grid' ];
    if (grid.rendered) {
      grid.loadMask.show();
    }

    if (this.action == 'delete') {
      var record;

      record = $CW[this.name + 'Store'].getById(this.id);
      record && $CW[this.name + 'Store'].remove(record);

      record = $CW[this.name + 'GridStore'].getById(this.id);
      record && $CW[this.name + 'GridStore'].remove(record);
    }

    Ext.Ajax.request({
      url: Scada.reqUrl('comfoway', this.mode),
      success: $CW.onConfirmComplete.createDelegate(this),
      failure: $CW.onConfirmComplete.createDelegate(this),
      params: Scada.encodeData({ id: this.id })
    });

  }
};

$CW.showSpcPanel = function() {
  var mode = this;

  Ext.each($CW.pList, function(type) {
    Ext.getCmp('comfoway-btn-' + type).toggle(mode == type);
  });

  $CW.mainSpcPanel.layout.setActiveItem('comfoway-grid-' + mode);
};
$CW.myTThider = function(tt) { 
          var timeout;
          tt.getEl().on('mouseout', function(){
              timeout = window.setTimeout(function(){
                  tt.hide();
              }, 100);
          });
          tt.getEl().on('mouseover', function(){
              window.clearTimeout(timeout);
          });
          Ext.getCmp(tt.target.dom.id).getEl().on('mouseout', function(){
              timeout = window.setTimeout(function(){
                  tt.hide();
              }, 100);
          });
        };

$CW.showForm = function(itemId) {
  var form = $CW[ this.name + 'Form' ];
  var formWindow = $CW[ this.name + 'FormWindow' ];

  form.reset();
  formWindow.show().center();

  if (typeof itemId != 'number' && typeof itemId != 'string') {
    itemId = 0;
  }

  if (itemId || this.type == 'event') {
    form.load({
      url: Scada.reqUrl('comfoway', 'form'),
      params: Scada.encodeData({ id: itemId }),
      waitMsg: $tr('loading')
    });
  }

  //enable the name and desc for custom general settings = id > 10
  if (this.type == 'general') {
    //console.log(itemId, (itemId > 10 || itemId == 0));
    if (itemId > 10 || itemId == 0) {
      Ext.getCmp('comfoway-general-form-name').enable();
      Ext.getCmp('comfoway-general-form-desc').enable();
    } else {
      Ext.getCmp('comfoway-general-form-name').disable();
      Ext.getCmp('comfoway-general-form-desc').disable();
    }
  }

    $CW.intervalTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-' + this.type + '-form-interval').getEl(), 
      html: $tr('comfoway_tiptext_interval'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: $CW.myTThider,
      }
    });
    $CW.updateonlyTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-' + this.type + '-form-updateonly').getEl(), 
      html: $tr('comfoway_tiptext_updateonly'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: $CW.myTThider,
      }
    });
    $CW.wroldTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-' + this.type + '-form-wrold').getEl(), 
      html: $tr('comfoway_tiptext_wrold'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: $CW.myTThider,
      }
    });
    $CW.addressTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-' + this.type + '-form-address').getEl(), 
      html: $tr('comfoway_tiptext_address'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: $CW.myTThider,
      }
    });

  if (this.type == 'eventX') {
    $CW.seteNameStore();
    $CW.setEventDetails();
    $CW.eventIDTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-event-form-escid').getEl(), 
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: function(tt) { tt.body.update(eventIDTipHTML);$CW.myTThider(tt); },
        render: function(tt) { tt.body.update(eventIDTipHTML); console.log(eventIDTipHTML);},
      }
    });
    $CW.eventOptionTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-event-form-escoption').getEl(), 
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: function(tt) { tt.body.update(eventOptionTipHTML);$CW.myTThider(tt); },
        render: function(tt) { tt.body.update(eventOptionTipHTML); },
      }
    });
    $CW.eventValueTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-event-form-knxvalue').getEl(), 
      html: $tr('comfoway_tiptext_evtknxvalue'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: $CW.myTThider,
      }
    });
  }
  if (this.type == 'commandX') {
    $CW.commandIDTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-command-form-escid').getEl(), 
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: function(tt) { tt.body.update(commandIDTipHTML);$CW.myTThider(tt); },
        render: function(tt) { tt.body.update(commandIDTipHTML);},
      }
    });
    $CW.commandOptionTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-command-form-escoption').getEl(), 
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: function(tt) { tt.body.update(commandOptionTipHTML);$CW.myTThider(tt); },
        render: function(tt) { tt.body.update(commandOptionTipHTML); },
      }
    });
    $CW.commandValueTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-command-form-knxvalue').getEl(), 
      html: $tr('comfoway_tiptext_cmdknxvalue'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: $CW.myTThider,
      }
    });
    $CW.commandValueTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-command-form-knxfb').getEl(), 
      html: $tr('comfoway_tiptext_cmdknxfeedback'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: $CW.myTThider,
      }
    });
  }
  if (this.type == 'statusX') {
    $CW.statusIDTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-status-form-escid').getEl(), 
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: function(tt) { tt.body.update(statusIDTipHTML);$CW.myTThider(tt); },
        render: function(tt) { tt.body.update(statusIDTipHTML);},
      }
    });
    $CW.statusOptionTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-status-form-escoption').getEl(), 
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: function(tt) { tt.body.update(statusOptionTipHTML);$CW.myTThider(tt); },
        render: function(tt) { tt.body.update(statusOptionTipHTML); },
      }
    });
    $CW.statusResintTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-status-form-knxresint').getEl(), 
      html: $tr('comfoway_tiptext_stsresendint'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: function(tt) { $CW.myTThider(tt); },
      }
    });
    $CW.statusResvalTip = new Ext.ToolTip({
      target: Ext.getCmp('comfoway-status-form-knxresval').getEl(), 
      html: $tr('comfoway_tiptext_stsresendval'),
      anchor: 'left',
      dismissDelay: 0,
      showDelay: 100,
      autoHide: false,
      listeners: {
        show: function(tt) { $CW.myTThider(tt); },
      }
    });
  }

//  $CW.elementStore.reload();
console.log('form loaded correctly',itemId,this);
};

$CW.hideForm = function() {
  $CW[ this + 'FormWindow' ].hide();
};

$CW.submitForm = function() {
  var form = $CW[ this.name + 'Form' ];
  Ext.get('comfoway-' + this.type + '-form-type').dom.value = this.type;
console.log('submitting form '+this.name + 'Form',form.isValid());

  form.submit({
    mode: 'json',
    exclude: 'script',
    waitMsg: $tr('loading'),
    clientValidation: !form.isValid()
  });
console.log('submitted form '+this.name + 'Form');
  $CW.enableReload(true);
};

$CW.showEditor = function(id, object) {
  var param = object ? 'object' : 'id', win;

  win = window.open('/cgi-bin/scada/editor.cgi?' + param + '=' + id);

  if (object) {
    win.onload = function() {
      $CW.eStore.reload();
    };
  }
};

$CW.IsNumeric = function(val) {
    return Number(parseFloat(val))==val;
};


$CW.init = function() {
  Ext.each($CW.pList, function(item) {
    var name = item[ 0 ];
    var bindParams = { name: name, type: item };

    var formPanel = Ext.getCmp('comfoway-' + item + '-form');
    var form = formPanel.getForm();

    $CW[ name + 'FormPanel' ] = formPanel;
    $CW[ name + 'Form' ] = form;

    form.on('actioncomplete', function(form, action) {
      if (action.type == 'load') {
        var data = action.result.data;
        if (data) {
          Ext.each([ '','2','3','4','5','6','7','8' ], function(f) {

            if (data['address'+f]) {
              address = Scada.decodeGroupAddress(data['address'+f]);
//console.log(data['address'+f],address);
              Ext.getCmp('comfoway-'+item+'-form-address'+f).setValue(address);
            }
          });
          descr = data.description + '';
          var regexNL = new RegExp(String.fromCharCode(167), "g");
          descr = descr.replace(regexNL ,'\n');
          Ext.getCmp('comfoway-'+item+'-form-description').setValue(descr);
        }
      }
      else if (action.type == 'submit') {
        $CW.hideForm.apply(this);
        $CW[ this + 'Store' ].reload();
      }
    }, name);

    form.on('Xactioncomplete', function(form, action) {
      if (action.type == 'load') {
        var data = action.result.data;
        if (data) {
          Ext.each([ '','2','3','4','5','6','7','8' ], function(f) {

            if (data['address'+f]) {
              address = Scada.decodeGroupAddress(data['address'+f]);
//console.log(data['address'+f],address);
              Ext.getCmp('comfoway-'+item+'-form-address'+f).setValue(address);
            }
          });
        }
      }
    });

    form.on('beforeaction', function(form, action) {
      $CW.allowSubmit=form.isValid()
      if (action.type == 'submit' && form.isValid() && item!='general') {
//        var data = action.result.data;
//        if (data) {
          var addressfld
          Ext.each([ '','2','3','4','5','6','7','8' ], function(f) {
            addressfld = Ext.getCmp('comfoway-'+item+'-form-address'+f)
            if (addressfld .getValue()!='') {
              address = Scada.encodeGroupAddress(addressfld.getValue());
console.log('encoding addresses' , addressfld.getValue(),address);
              addressfld.setValue(address);
//              data['address'+f]=address;
            }
          });
//        }
//        var values = [], v;

//        values.push($CW.dtMinute.getValue());
//        values.push($CW.dtHour.getValue());
//        values.push($CW.dtMonthday.getValue());

//        v = $CW.dtMonth.getValue();
//        values.push((v == '1,2,3,4,5,6,7,8,9,10,11,12') ? '*' : v);

//        v = $CW.dtWeekday.getValue();
//        values.push((v == '0,1,2,3,4,5,6' || v == '1,2,3,4,5,6,0') ? '*' : v);

//        $CW.dtParams.setValue(values.join(' '));
      }
    });

    $CW[name + 'Store'].on('beforeload', function() {
      $CW[name + 'Pagination'].refresh.disable();
      $CW[name + 'Pagination'].disableAll();
    });
    $CW[name + 'Store'].on('load', function(store) {
      var data = store.reader.jsonData.data, sort = $CW[name + 'GridStore'].getSortState();

      $CW[name + 'GridStore'].loadData(data, true);
      $CW[name + 'GridStore'].sort(sort.field, sort.direction);

      if (!$CW[name + 'Pagination'].init) {
        $CW[name + 'Pagination'].init = true;
        $CW[name + 'Pagination'].moveFirst();
      }

      $CW[name + 'Pagination'].refresh.enable();

//      if (!$O.extStoreReady || $O.updateExt) {
//        $O.onBlur();
//        $O.autoUpdate = true;
//        $O.extStoreReady = true;
//        $O.updateExt = false;
//      }
    });


    var button = Ext.getCmp('comfoway-btn-' + item);
    button.setHandler($CW.showSpcPanel, item);
    button.menu.get('comfoway-menu-' + item + '-list').setHandler($CW.showSpcPanel, item);
    button.menu.get('comfoway-menu-' + item + '-add').setHandler($CW.showForm, bindParams);

    if (item=='general') {
	Ext.getCmp('comfoway-bbar-' + item + '-add').setHandler($CW.showForm, bindParams);
    }

    Ext.getCmp('comfoway-' + item + '-form-submit').setHandler($CW.submitForm, bindParams);
    Ext.getCmp('comfoway-' + item + '-form-cancel').setHandler($CW.hideForm, name);

    $CW[ name + 'Grid' ].on('cellclick', function(grid, rowIndex, columnIndex) {
      var id = grid.getStore().getAt(rowIndex).get('id');
      var fieldName = grid.getColumnModel().getDataIndex(columnIndex);

      if (fieldName == 'duplicate') {
        $CW[ this.name + 'Grid' ].loadMask.show();

        Ext.Ajax.request({
          url: Scada.reqUrl('comfoway', 'duplicate'),
          success: $CW.onConfirmComplete.createDelegate(this),
          failure: $CW.onConfirmComplete.createDelegate(this),
          params: Scada.encodeData({ id: id })
        });
      }
      else if (fieldName == 'delete' || fieldName == 'active' || fieldName == 'source') {
//        var mode = ((fieldName == 'active') ? 'status' : fieldName) + ((item=='general') ? 'general' : '');
        var mode = ((fieldName == 'active') ? 'status' : fieldName) ;
        Ext.Msg.confirm(
          $tr('comfoway_' + mode + ((item=='general') ? 'general' : '') + '_title'),
          $tr('comfoway_' + mode + ((item=='general') ? 'general' : '') + '_confirm'),
          $CW.onConfirm,
          { name: this.name, id: id, mode: mode, type:item, action:fieldName }
        );
      }
      else if (fieldName == 'editor') {
        $CW.showEditor(id);
      }
      else {
        $CW.showForm.apply(this, [ id ]);
      }
    }, bindParams);
  });

  $CW.dtParams = Ext.getCmp('scripting-scheduled-form-params');
  $CW.dtMinute = Ext.getCmp('scripting-scheduled-form-minute');
  $CW.dtHour = Ext.getCmp('scripting-scheduled-form-hour');
  $CW.dtMonthday = Ext.getCmp('scripting-scheduled-form-monthday');
  $CW.dtMonth = Ext.getCmp('scripting-scheduled-form-month');
  $CW.dtWeekday = Ext.getCmp('scripting-scheduled-form-weekday');

//  Ext.Ajax.request({
//    url: '/scada/help/' + Scada.Lang + '/scripting-scheduled.html',
//    success: function(r) {
//      $CW.cronHelp = r.responseText;
//    }
//  });

  Ext.each([ $CW.dtMinute, $CW.dtHour, $CW.dtMonthday ], function(f) {
    f.on('afterrender', function(f) {
      f.label.addClass('x-label-hint');
      Ext.QuickTips.register({
        target: f.label,
        cls: 'x-html-tip',
        text: $CW.cronHelp
      });
    });
  });

  $CW.gStore.reload();
  $CW.sStore.reload();
  $CW.cStore.reload();

  $CW.initReload();


};

Scada.Modules.push($CW);
